Public Member Functions | Private Slots | Private Member Functions | Private Attributes

# ShX10 Class Reference

Interfaces the X10 network using a CM12U controller. More...

`#include <shx10.h>`

Inheritance diagram for ShX10:
[legend]
Collaboration diagram for ShX10:
[legend]

List of all members.

## Public Member Functions
| ShX10 (QObject *parent=0)
| Constructor of ShX10.
virtual | ~ShX10 ()
virtual bool | init (QString param)
| Initialization of the plug-in.
virtual void | updatePins (const QList< ShPin > &pins)
virtual void | processMessage (ShMessagePtr message)
| Enqueue the incomming messages.
## Private Slots
void | emitAck ()
| Slot invoked after successful X-10 transmission.
void | emitErr (QString reason)
| Slot invoked after X-10 transmission failed.
## Private Member Functions
void | processNextMessage ()
| Hands over the next message to the x10interface object.
## Private Attributes
X10Interface * | mInterface
QQueue< ShMessagePtr > | mMessageQueue

## Detailed Description

Interfaces the X10 network using a CM12U controller.

Definition at line 35 of file shx10.h.

## Constructor & Destructor Documentation

ShX10::ShX10 | ( | QObject * | parent = `0` | ) |

Constructor of ShX10.

Parameters:

  | parent | Pointer to the parent object

Definition at line 27 of file shx10.cpp.

virtual ShX10::~ShX10 | ( |  | ) | `[inline, virtual]`

Definition at line 42 of file shx10.h.

## Member Function Documentation

void ShX10::emitAck | ( |  | ) | `[private, slot]`

Slot invoked after successful X-10 transmission.

Definition at line 115 of file shx10.cpp.

References ShObjectHelper::ackMessage(), mMessageQueue, and processNextMessage().

Referenced by init().

Here is the call graph for this function:

Here is the caller graph for this function:

void ShX10::emitErr | ( | QString | reason | ) | `[private, slot]`

Slot invoked after X-10 transmission failed.

Definition at line 129 of file shx10.cpp.

References ShObjectHelper::errorMessage(), mMessageQueue, and processNextMessage().

Referenced by init(), and processNextMessage().

Here is the call graph for this function:

Here is the caller graph for this function:

bool ShX10::init | ( | QString | param | ) | `[virtual]`

Initialization of the plug-in.

Parameters:

  | param | Defines a port that is the X10 controller connected to

Returns:
  true if the plug-in has been initialized successfully

Implements ShObject.

Definition at line 37 of file shx10.cpp.

References emitAck(), emitErr(), mInterface, and X10Interface::sendTime().

Here is the call graph for this function:

void ShX10::processMessage | ( | ShMessagePtr | message | ) | `[virtual]`

Enqueue the incomming messages.

Parameters:

  | message | Shared pointer to the message

Definition at line 58 of file shx10.cpp.

References mMessageQueue, and processNextMessage().

Here is the call graph for this function:

void ShX10::processNextMessage | ( |  | ) | `[private]`

Hands over the next message to the x10interface object.

Definition at line 74 of file shx10.cpp.

References X10Interface::dimLights(), emitErr(), mInterface, mMessageQueue, X10Interface::onOffAllLights(), X10Interface::onOffDevices(), and X10Interface::state().

Referenced by emitAck(), emitErr(), and processMessage().

Here is the call graph for this function:

Here is the caller graph for this function:

virtual void ShX10::updatePins | ( | const QList< ShPin > & | pins | ) | `[inline, virtual]`

Implements ShObject.

Definition at line 44 of file shx10.h.

## Member Data Documentation

X10Interface* ShX10::mInterface`[private]`

Definition at line 54 of file shx10.h.

Referenced by init(), and processNextMessage().

QQueue<ShMessagePtr> ShX10::mMessageQueue`[private]`

Definition at line 55 of file shx10.h.

Referenced by emitAck(), emitErr(), processMessage(), and processNextMessage().

The documentation for this class was generated from the following files:

- shx10/shx10.h
- shx10/shx10.cpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends